unit TblSpy;

(***********************************************************************
 *                                                                     *
 *  Copyright (C) 1997-19..                                            *
 *  Arbeitsgruppe KI-Labor Fachbereich Informatik Universitaet Bremen  *
 *                                                                     *
 *  Version     :       2.0                                            *
 *                                                                     *
 *  Beschreibung:                                                      *
 *                                                                     *
 *  Autor       :       Erol S. Uzuner                                 *
 *                                                                     *
 *  Datum       :       Dezember 1999                                  *
 *                                                                     *
 *                                                                     *
 *  Aenderungen :                                                      *
 *  Datum        Autor          Beschreibung                           *
 *                                                                     *
 ***********************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, Db, DBTables, ExtCtrls, ListerForm, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    ffnen1: TMenuItem;
    Window1: TMenuItem;
    Tiled1: TMenuItem;
    Cascade1: TMenuItem;
    ArrangeIcons1: TMenuItem;
    N1: TMenuItem;
    CloseAll1: TMenuItem;
    MinimizeAll1: TMenuItem;
    NormalizeAll1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Export1: TMenuItem;
    Html1: TMenuItem;
    SaveDialog1: TSaveDialog;
    tblUpdate: TTable;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ffnen1Click(Sender: TObject);
    procedure Tiled1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure ArrangeIcons1Click(Sender: TObject);
    procedure CloseAll1Click(Sender: TObject);
    procedure MinimizeAll1Click(Sender: TObject);
    procedure NormalizeAll1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Html1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure SpyTable(tbl : String);
    function FieldTypeAsString(ft : TFieldType) : String;
//    function FieldKindAsString(fk : TFieldKind) : String;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.FieldTypeAsString(ft : TFieldType) : String;
begin
  case ft of
     ftUnknown:	  Result := 'Unknown'; //Unbekannt oder unbestimmt
     ftString:	  Result := 'String'; //Feld fr Zeichen oder Strings
     ftSmallint:  Result := 'Smallint'; //16-Bit-Integer-Feld
     ftInteger:	  Result := 'Integer'; //32-Bit-Integer-Feld
     ftWord:	  Result := 'Word'; //Vorzeichenloses 16-Bit-Integer-Feld
     ftBoolean:	  Result := 'Boolean'; //Feld vom Typ Boolean
     ftFloat:	  Result := 'Float'; //Numerisches Gleitkommafeld
     ftCurrency:  Result := 'Currency'; //Whrungsfeld
     ftBCD:	  Result := 'BCD'; //Binrcodiertes Dezimalfeld
     ftDate:	  Result := 'Date'; //Feld fr Datum
     ftTime:	  Result := 'Time'; //Feld fr Zeit
     ftDateTime:  Result := 'DateTime'; //Feld fr Datum und Zeit
     ftBytes:	  Result := 'Bytes'; //Festgelegte Zahl von Bytes (binre Speicherung)
     ftVarBytes:  Result := 'VarBytes'; //Variable Zahl von Bytes (binre Speicherung)
     ftAutoInc:	  Result := 'AutoInc'; //Automatisch inkrementiertes 32-Bit-Integer-Feld als Zhler
     ftBlob:	  Result := 'Blob'; //Binres Large-OBject-Feld (BLOB)
     ftMemo:	  Result := 'Memo'; //Memofeld fr Texte
     ftGraphic:	  Result := 'Graphic'; //Feld fr Bitmaps
     ftFmtMemo:	  Result := 'FmtMemo'; //Formatiertes Memofeld fr Texte
     ftParadoxOle:Result := 'ParadoxOle'; //Paradox OLE-Feld
     ftDBaseOle:  Result := 'DBaseOle'; //dBASE OLE-Feld
     ftTypedBinary:Result := 'TypedBinary'; //Typisiertes Binrfeld
     ftCursor:	  Result := 'Cursor'; //Nicht auf Feldkomponenten anwendbar
     else Result := '';
  end;
end;

procedure TForm1.SpyTable(tbl : String);
var fl : TfrmLister;
    i : Integer;
    str : String;
begin
    fl := TfrmLister.Create(Self);
    fl.Caption := ExtractFileName(tbl);
    with tblUpdate do begin
     Close;
     Tablename := tbl;
     Open;
     str := '';
     for i := 0 to FieldCount -1 do begin
        str := Fields[i].FieldName;
        if Fields[i].isIndexField then  str := str + '*';
        str := str + ' ' + FieldTypeAsString(Fields[i].DataType);
        str := str + ' ' + IntToStr(Fields[i].size);
      fl.HeaderListbox1.Items.Add(str);
    end;
    Close;
  end;
  fl.Show;
end;
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  while MDIChildCount > 0 do MDIChildren[0].Free;
end;

procedure TForm1.ffnen1Click(Sender: TObject);
var i : Integer;
    stl : TStringList;
begin
 if OpenDialog1.Execute then begin
   stl := TStringList.Create;
   stl.Assign(OpenDialog1.Files);
   stl.Sort;
   for i := stl.Count -1 downto 0 do
         SpyTable(stl.strings[i]);
   stl.Free;
  end;
end;

procedure TForm1.Tiled1Click(Sender: TObject);
begin Tile;
end;

procedure TForm1.Cascade1Click(Sender: TObject);
begin Cascade;
end;

procedure TForm1.ArrangeIcons1Click(Sender: TObject);
begin ArrangeIcons;
end;

procedure TForm1.CloseAll1Click(Sender: TObject);
begin while MDIChildCount > 0 do MDIChildren[0].Free;
end;

procedure TForm1.MinimizeAll1Click(Sender: TObject);
var i : integer;
begin
 for i:= 0 to MDIChildCount -1 do
    if MDIChildren[0].WindowState <> wsMinimized then MDIChildren[0].WindowState := wsMinimized;
end;

procedure TForm1.NormalizeAll1Click(Sender: TObject);
var i : integer;
begin
 for i:= 0 to MDIChildCount -1 do
    if MDIChildren[i].WindowState <> wsNormal then MDIChildren[i].WindowState := wsNormal;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin Close;
end;

procedure TForm1.Html1Click(Sender: TObject);

   procedure HtmlHeader(stl : TStringList);
   begin
          stl.add('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">');
          stl.add('<HTML>');
          stl.add('<HEAD>');
          stl.add('<TITLE>Tables</TITLE>');
          stl.add('</HEAD>');
          stl.add('<BODY background="backgr.jpg" leftmargin="40">');
   end;
   procedure HtmlEnd(stl : TStringList);
   begin
          stl.add('</BODY>');
          stl.add('</HTML>');
   end;
   procedure HtmlCaption(stl : TStringList);
   begin
          stl.add('<H1>TABELLEN</H1>');
   end;
   procedure HtmlTableLinks(stl : TStringList);
   var i, j, rowcnt : Integer;
       st : TStringList;
       tdstr : String;
   begin
      st := TStringList.Create();
      for i:= 0 to MDIChildCount -1 do begin
          st.add( Format('<A HREF="#%s">%s</A>', [MDIChildren[i].Caption, MDIChildren[i].Caption]));
      end;

      st.Sort;
      stl.Add('<p>');
      stl.add('<table cellspacing="2" cellpadding="2" border="1" frame="box" rules="NONE" bgcolor="#ffffee" style="font-family: Arial; font-size: 10pt;">');
      stl.add('<tr>');
      rowcnt := 2;
      tdstr := '<td>';
      for i:=  0 to st.count-1 do begin
          stl.add(tdstr);
          stl.add(st.strings[i]);
          stl.add('</td>');
          if (i > 0) AND (((i+1) mod 5) = 0) then begin
                stl.add('</tr>');
                case rowcnt of
                  1, 2 : begin
                            INC(rowcnt);
                            tdstr := '<td>';
                         end;
                  3 : begin
                        INC(rowcnt);
                        tdstr := '<td bgcolor="#ffffaa">';
                      end;
                  4 : begin
                         rowcnt := 1;
                         tdstr := '<td bgcolor="#ffffaa">';
                      end;
                end;
                if (i < st.count-1) then stl.add('<tr>')
          end;
          if (i = st.count-1) then begin
                j := 1;
                while ((i+j) mod 5) <> 0 do  begin
                      stl.add(tdstr + '&nbsp;</td>');
                      INC(j);
                end;
                stl.add('</tr>');
           end;

      end;

      stl.add('</table>');
      stl.Add('</p>');
      st.Free;
   end;

   procedure HtmlTableSplit(stl : TStringList);
   begin
        stl.add('<tr><td colspan="2" bgcolor="#dddddd"> &nbsp;</td></tr>');
   end;

var i : Integer;
    stl : TStringList;
begin
   if SaveDialog1.Execute then begin
     stl := TStringList.Create;
     HtmlHeader(stl);
     HtmlCaption(stl);
     HtmlTableLinks(stl);
     stl.add('<table cellspacing="2" celpadding="2" border="0">');
     for i:= 0 to MDIChildCount -1 do begin
       stl.add('<tr><td>');
       TfrmLister(MDIChildren[i]).ToHtml(stl);
       stl.add('</td><td>&nbsp;Erluterung zur Tabelle</td></tr>');
       HtmlTableSplit(stl);
     end;
     stl.add('</table>');
     HtmlEnd(stl);
     stl.SaveToFile(SaveDialog1.FileName);
     stl.Free;
   end;
end;

end.
